/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_FADER_H_
#define __GDAM_FADER_H_


typedef struct _GdamFader GdamFader;
typedef struct _GdamFaderClass GdamFaderClass;

#include <gdam/gdamfilter.h>

typedef enum _GdamFaderMode {
	GDAM_FADER_TERMINATES,
	GDAM_FADER_LOOPS,
	GDAM_FADER_SHELF,
} GdamFaderMode;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_fader_get_type();
#define GDAM_TYPE_FADER			(gdam_fader_get_type ())
#define GDAM_FADER(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_FADER, GdamFader))
#define GDAM_FADER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_FADER, GdamFaderClass))
#define GDAM_IS_FADER(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_FADER))
#define GDAM_IS_FADER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_FADER))

struct _GdamFaderClass {
	GdamFilterClass		fader_class;
};
struct _GdamFader {
	GdamFilter			fader;

	gint64				position;
	int				terminates;
	int				num_time_vols;
	gint64*				time_vols;
	GdamFaderMode			mode;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
