/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Mike Radford, Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
	mrad@blorf.com <Mike Radford>
*/
#ifndef __GDAM_SPATIAL_STEREO_H_
#define __GDAM_SPATIAL_STEREO_H_


typedef struct _GdamSpatialStereo GdamSpatialStereo;
typedef struct _GdamSpatialStereoClass GdamSpatialStereoClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <gdam/gdambufferingfilter.h>

GtkType gdam_spatial_stereo_get_type();
#define GDAM_TYPE_SPATIAL_STEREO			(gdam_spatial_stereo_get_type ())
#define GDAM_SPATIAL_STEREO(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SPATIAL_STEREO, GdamSpatialStereo))
#define GDAM_SPATIAL_STEREO_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SPATIAL_STEREO, GdamSpatialStereoClass))
#define GDAM_IS_SPATIAL_STEREO(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SPATIAL_STEREO))
#define GDAM_IS_SPATIAL_STEREO_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SPATIAL_STEREO))

struct _GdamSpatialStereoClass {
	GdamBufferingFilterClass		spatial_stereo_class;
};

struct _GdamSpatialStereo {
	GdamBufferingFilter			spatial_stereo;
	double lpos_x, lpos_y, lpos_z;
	double rpos_x, rpos_y, rpos_z;
	double lear_x, lear_y, lear_z;
	double rear_x, rear_y, rear_z;
	double speed_of_sound;
	double unit_gain_dist;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
